use super::bridge::Bridge;
use crate::protocol::packets::Handshake;
use thiserror::Error;

#[derive(Error, Debug)]
pub enum RouterError {
    #[error("no server with such hostname has been found")]
    NoServer,

    #[error("unable to connect to server: {0}")]
    Unreachable(std::io::Error),
}

#[async_trait::async_trait]
pub trait Router: Send + Sync {
    async fn route(&self, client: &Handshake) -> Result<Bridge, RouterError>;
}
